/*
@version $Id: barteditor.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	mod:[
		{name: 'sys', files: ['editor.js']},
		{name: '{C#MODNAME}', files: ['bartlib.js', 'scopeview.js', 'categorylist.js']}
	]
};
Component.entryPoint = function(NS){

	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var LNG = Brick.util.Language.geta(['mod', '{C#MODNAME}']);
	
	var TMG = this.template,
		initCSS = false,
		buildTemplate = function(w, ts){
		if (!initCSS){
			Brick.util.CSS.update(Brick.util.CSS['{C#MODNAME}']['{C#COMNAME}']);
			delete Brick.util.CSS['{C#MODNAME}']['{C#COMNAME}'];
			initCSS = true;
		}
		w._TM = TMG.build(ts); w._T = w._TM.data; w._TId = w._TM.idManager;
	};

	
	var BarterEditorWidget = function(container, bart, callback){
		this.init(container, bart, callback);
	};
	BarterEditorWidget.prototype = {
		init: function(container, bart, callback){
			this.barter = bart;
			this.callback = callback;

			buildTemplate(this, 'widget');
			var __self = this;
			var TM = this._TM,
				gel = function(nm){ return TM.getEl('widget.'+nm); };
				
			container.innerHTML = TM.replace('widget', {
				'disnew': bart.id > 0 ? 'none' : '',
				'disedit': bart.id > 0 ? '' : 'none',
				'isdraft': bart.isdraft ? '' : 'none',
				'isndraft': !bart.isdraft ? '' : 'none'
			});
			
			this.category = new NS.CategorySelectWidget(gel('catalog'), bart.catid);
			this.scopeWidget = new NS.ScopeListWidget(gel('scope'));
			
			gel('title').value = bart.title;
			gel('descript').value = NS.textToEdit(bart.descript);
			
			if (bart.id == 0){
				Dom.setStyle(gel('bpublic'), 'display', '');
				Dom.setStyle(gel('bpublicsave'), 'display', 'none');
			}
			
			E.on(container, 'click', function(e){
				var el = E.getTarget(e);
				if (__self.onClick(el)){ E.preventDefault(e); }
			});
		},
		destroy: function(){
			var el = this._TM.getEl('widget.id');
			el.parentNode.removeChild(el);
		},
		onClick: function(el){
			if (this.scopeWidget.onClick(el)){ return true; }
			
			this.errorHide();
			var tp = this._TId['widget'];
			switch(el.id){
			case tp['bpublic']: 
			case tp['bpublicsave']: 
				this.barterPublic(); return true;
			case tp['bdraft']: 
			case tp['bdraftsave']: 
				this.barterDraft(); return true;
			case tp['bcancel']: this.cancel(); return true;
			}
			return false;
		},
		errorHide: function(){
			for (var i=1;i<7;i++){
				Dom.setStyle(this._TM.getEl('widget.err'+i), 'display', 'none');
			}
		},
		errorShow: function(err){
			this.errorHide();
			Dom.setStyle(this._TM.getEl('widget.err'+err), 'display', '');
		},
		cancel: function(){
			this.callback('cancel');
			this.destroy();
		},
		getSaveData: function(){
			var TM = this._TM,
				gel = function(nm){ return TM.getEl('widget.'+nm); };

			var d = {
				'id': this.barter.id,
				'catid': this.category.getValue(),
				'tl': L.trim(gel('title').value),
				'dsc': L.trim(gel('descript').value)
			};

			var cdsc = L.trim(d['dsc']);
			var err = 0;
			if (d['catid'] == 0){ err = 1;
			}else if (d['tl'].length < 5){ err = 2;
			}else if (cdsc.length < 5){ err = 3;
			}else if (d['agr'] == 0){
				if (d['cst']<1){ err = 4;
				}else if (d['cctp'] == 0){ err = 5;
				}else if (d['pctp'] == 0){ err = 6;
				}
			}
			
			if (err > 0){
				this.errorShow(err);
				return null;
			}
			return d;
		},
		barterPublic: function(){
			var sd = this.getSaveData();
			if (L.isNull(sd)){ return ; }
			sd['dft'] = 0;
			this.save(sd);
		},
		barterDraft: function(){
			var sd = this.getSaveData();
			if (L.isNull(sd)){ return ; }
			sd['dft'] = 1;
			this.save(sd);
		},
		save: function(sd){
			
			var TM = this._TM, 
				__self = this,
				bart = this.barter;
			
			Dom.setStyle(TM.getEl('widget.btns'), 'display', 'none');
			Dom.setStyle(TM.getEl('widget.prcsave'), 'display', '');
			
			NS.barterManager.barterSave(sd, function(d){
				if (L.isNull(d)){
					__self.cancel();
				}else{
					bart.update(d['p']);
					__self.callback('save');
					__self.destroy();
				}
			});
		}
	};
	NS.BarterEditorWidget = BarterEditorWidget;
};