/*
@version $Id: barter.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	mod:[
		{name: '{C#MODNAME}', files: ['bartlib.js', 'categorylist.js']}
	]
};
Component.entryPoint = function(NS){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var buildTemplate = this.buildTemplate;
	
	var BarterWorkspaceWidget =  function(container, act, p){
		this.init(container, act, p);
	};
	BarterWorkspaceWidget.prototype = {
		init: function(container, act, p){
			
			this._action = act;
			this._actparam = p;
			
			var TM = buildTemplate(this, 'widget');
			container.innerHTML = TM.replace('widget');

			this.catsWidget = null;
			this.ws = {};
			
			var __self = this;
			NS.API.initBarterManager(function(man){
				__self.setGlobalParam(__self._action, __self._actparam);
			});
			
			this.wsMenuItem = p == 'my' ? 'my' : 'list';
		},
		setGlobalParam: function(act, p){
			this._action = act;
			this._actparam = p;
			
			if (L.isNull(NS.barterManager)){
				// идет загрузка PM, ждем, после загрузки вызовет этот метод
				return;
			}
			
			var gAct = this._action, gPrm = this._actparam;

			var __self = this,
				ws = this.ws,
				TM = this._TM,
				gel = function(nm){ return TM.getEl('widget.'+nm); },
				setStyle = function(nm, v){ Dom.setStyle(gel(nm), 'display', v); };

			setStyle('loading', 'none');
			setStyle('page', '');

			if (L.isNull(this.catsWidget)){
				this.catsWidget = new NS.CategoryColListWidget(gel('catlist'));
				this.catsWidget.selectChangedEvent.subscribe(this.onCatalogChaged, this, true);
			}
			var catsWidget = this.catsWidget;

			var showLoading = function(wn){
				setStyle('mloading', '');
				setStyle('content', 'none');
			};
			var hideLoading = function(wn){
				setStyle('mloading', 'none');
				setStyle('content', '');
				for (var n in ws){setStyle(n,wn==n?'':'none');}
			};
			
			switch(gAct){
			case 'view': 
				var showProjView = function(){
					if (ws['bartview']){
						ws['bartview'].destroy();
					}
					ws['bartview'] = new NS.BarterViewWidget(gel('bartview'), gPrm, function(bart){
						hideLoading('bartview');
						if (!L.isNull(bart)){
							__self.setCatalogId(bart.catid);
						}
					});
				};
				if (!ws['bartview']){
					showLoading();
					Brick.ff('{C#MODNAME}', 'bartview', showProjView);
				}else{
					showProjView();
				}
				break;
			default:
				var catid = gPrm;
			
				if (!ws['bartlist']){
					showLoading();
					Brick.ff('{C#MODNAME}', 'bartlist', function(){
						ws['bartlist'] = new NS.BarterListWidget(gel('bartlist'), catid);
						hideLoading('bartlist');
					});
				}else{
					ws['bartlist'].setConfig({'catid': catid});
					hideLoading('bartlist');
				}
				this.setCatalogId(catid);
				break;
			}
		},
		onCatalogChaged: function(){
			if (this._blockCatsWEvent){ return; }

			var catid = this.catsWidget.getValue();
			Brick.Page.reload(NS.navigator.barter.list(catid));
		},
		setCatalogId: function(catid){
			this._blockCatsWEvent = true;
			this.catsWidget.setValue(catid);
			this._blockCatsWEvent = false;
		},
		destroy: function(){
			if (!L.isNull(this.catsWidget)){
				this.catsWidget.selectChangedEvent.unsubscribe(this.onCatalogChaged);
			}
		}		
	};
	NS.BarterWorkspaceWidget = BarterWorkspaceWidget;

};