/*
@version $Id: bartlib.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = { 
	mod:[
        {name: '{C#MODNAME}', files: ['lib.js']}
	]		
};
Component.entryPoint = function(NS){

	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang,
		R = NS.roles;

	var Barter = function(d){
		d = L.merge({
			'catid': 0,
			'uid': 0,
			'tl': '',
			'dsc': '',
			'dft': 0,
			'pdt': 0,
			'acnt': 0
		}, d || {});
		Barter.superclass.constructor.call(this, d);
	};
	YAHOO.extend(Barter, NS.Item, {
		init: function(d){
			this.answers = new BAnswerList();
			
			Barter.superclass.init.call(this, d);
		},
		update: function(d){
			this.type = 'barter';
			this.catid = d['catid']*1;
			this.userid = d['uid']*1;
			this.title = d['tl'];
			this.descript = d['dsc'];

			this.isdraft = d['dft']*1 > 0;
			this.pubdate = d['pdt']*1;
			this.answerCount = d['acnt']*1;
			
			this.answers.clear();
			this.answers.update(d['answers']);
		}
	});
	NS.Barter = Barter;
	
	var BarterList = function(cfg){
		this.cfg = cfg || null;
		this.dbCount = null;
		
		BarterList.superclass.constructor.call(this, [], Barter);
	};
	YAHOO.extend(BarterList, NS.ItemList, {});
	NS.BarterList = BarterList;

	var BAnswer = function(d){
		d = L.merge({
			'pid': 0, 'uid': 0, 'dsc': '', 'prv': 0,
			'dl': 0, 'ctid': 0, 'ccnt': 0
		}, d || {});
		BAnswer.superclass.constructor.call(this, d);
	};
	YAHOO.extend(BAnswer, NS.Item, {
		update: function(d){
			this.userid = d['uid']*1;
			this.barterid = d['pid'];
			
			this.descript = d['dsc'];
			this.isPrivate = d['prv']*1>0;
			this.date = d['dl']*1;
			this.commentid = d['ctid'];
			this.commentCount = d['ccnt'];
		}
	});
	NS.BAnswer = BAnswer;

	var BAnswerList = function(d){
		BAnswerList.superclass.constructor.call(this, d, BAnswer);
	};
	YAHOO.extend(BAnswerList, NS.ItemList, {});
	NS.BAnswerList = BAnswerList;
	
	var BarterManager = function(callback){
		this.init(callback);
	};
	BarterManager.prototype = {
		init: function(callback){
			NS.barterManager = this;
			
			// список просматриваемых проектов
			this.barterList = new BarterList();

			var __self = this;
			
			NS.API.initJobManager(function(){
				NS.life(callback, __self);
			});
			
		},
		ajax: function(data, callback){
			data['type'] = 'barter';
			NS.jobManager.ajax(data, callback);
		},
		buildList: function(cfg, d){
			var list = new NS.BarterList(cfg, d);
			if (!L.isNull(d)){
				list.dbCount = d['fcnt'];
				list.update(d['list']);
				NS.jobManager.updateCatProjCount(d['pcnt']);
			}
			return list;
		},
		loadList: function(cfg, callback){
			if (!L.isFunction(callback)){ return; }
			var __self = this;
			this.ajax({
				'do': 'barterlist',
				'catid': cfg['catid']
			}, function(d){
				var list = __self.buildList(cfg, d);
				callback(list);
			});
		},
		loadMoreList: function(list, callback){
			if (!L.isFunction(callback)){ return; }
			this.ajax({
				'do': 'barterlist',
				'catid': list.cfg['catid'],
				'next':list.count()
			}, function(d){
				if (!L.isNull(d)){
					list.update(d['list']);
				}
				callback();
			});
		},
		barterSave: function(sd, callback){
			sd['do'] = 'bartersave';
			this.ajax(sd, function(d){
				if (L.isFunction(callback)){
					callback(d);
				}
			});
		},
		_barterResult: function(d){
			if (L.isNull(d)){ return null; }
				
			var bart = this.barterList.get(d['p']['id']);
			if (L.isNull(bart)){
				bart = new NS.Barter(d['p']);
				this.barterList.add(bart);
			}else{
				bart.update(d['p']);
			}
			NS.jobManager.updateCatProjCount(d['pcnt']);
			NS.jobManager.users.update(d['users']);
			return bart;
		},
		barterLoad: function(bartid, callback){
			var __self = this;
			this.ajax({
				'do': 'barter',
				'bartid': bartid
			}, function(d){
				
				var bart = __self._barterResult(d);
				
				if (L.isFunction(callback)){ 
					callback(bart);
				}
			});
		},
		answerAppend: function(bartid, sd, callback){
			var __self = this;
			this.ajax({
				'do': 'answerappend',
				'bartid': bartid,
				'answer': sd
			}, function(d){
				
				d['bart'] = __self._barterResult(d['barter']);
				
				if (L.isFunction(callback)){ 
					callback(d);
				}
			});
		}
	};
	NS.BarterManager = BarterManager;
	NS.barterManager = null;
	
	NS.API.initBarterManager = function(callback){
		if (L.isNull(NS.barterManager)){
			NS.barterManager = new BarterManager(callback);
		}else{
			NS.life(callback, NS.barterManager);
		}
	};

};