/*
@version $Id: bartlist.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	mod:[
		{name: '{C#MODNAME}', files: ['bartview.js']}
	]
};
Component.entryPoint = function(NS){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var R = NS.roles;
	
	var LNG = Brick.util.Language.geta(['mod', '{C#MODNAME}']);
	
	var buildTemplate = this.buildTemplate;
	
	var BarterListWidget = function(container, catid){
		this.init(container, catid);
	};
	BarterListWidget.prototype = {
		init: function(container, catid){
			this._wList = [];
			this.newBarterWidget = null;
			this.catid = catid;
			
			buildTemplate(this, 'widget,rowempty');
			container.innerHTML = this._TM.replace('widget', {
				'lsturi': NS.navigator.barter.list()
			});
			
			var __self = this;
			E.on(container, 'click', function(e){
				var el = E.getTarget(e);
				if (__self.onClick(el)){ E.preventDefault(e); }
			});
			NS.API.initBarterManager(function(man){
				__self._onInitManager(man);
			});
		},
		destroy: function(){
			this._wlClear();			
		},
		_onInitManager: function(man){
			this.setConfig(this.catid);
			if (R['isWrite']){
				Dom.setStyle(this._TM.getEl('widget.baddbart'), 'display', '');
			}
		},
		onClick: function(el){
			this._wlForeach(function(w){
				w.onClick(el);
			});
			
			var tp = this._TId['widget'];
			switch(el.id){
			case tp['baddbart']: this.showCreateBarterWidget(); return true;
			case tp['bloadmore']: this.loadMore(); return true;
			}
			return false;
		},
		_wlForeach: function(f){ for (var i=0;i<this._wList.length;i++){ f(this._wList[i]); } },
		_wlClear: function(){ this._wlForeach(function(w){ w.destroy(); }); },
		showCreateBarterWidget: function(){
			if (!L.isNull(this.newBarterWidget)){ return; }
			
			var __self = this,
				bart = new NS.Barter();
			
			bart.catid = this.catid;
			
			var callback = function(tp, sd){
				if (tp == 'cancel'){
					__self.newBarterWidget = null;
				}else if (tp == 'save'){
					__self.newBarterWidget = null;
					__self.reloadList();
				}
			};
			this.newBarterWidget = new NS.BarterEditorWidget(this._TM.getEl('widget.newbart'), bart, callback);
		},
		reloadList: function(){
			this.setConfig(this.config);
		},
		renderList: function(list){
			this.currentList = list;
			var TM = this._TM, gel = function(nm){ return TM.getEl('widget.'+nm); };

			var wList = this._wList, 
				container = gel('list');
			
			this._wlClear();
			
			wList = [];
			container.innerHTML = '';
			
			list.foreach(function(bart){
				wList[wList.length] = new NS.BarterRowWidget(container, bart);
			});
			
			if (wList.length == 0){
				container.innerHTML = TM.replace('rowempty');
			}
			this._wList = wList;
			
			Dom.setStyle(gel('loadmore'), 'display', list.count() < list.dbCount ? '' : 'none');
		},
		setConfig: function(catid){
			this.catid = catid = catid || 0;
			var __self = this,
				TM = this._TM, gel = function(nm){ return TM.getEl('widget.'+nm); };
				
			var cat = NS.jobManager.categoryFind(catid);
			if (L.isNull(cat) && catid != 'my'){
				Dom.setStyle(gel('filt'), 'display', 'none');
			}else{
				Dom.setStyle(gel('filt'), 'display', '');
				if (catid == 'my'){
					gel('fpath').innerHTML = LNG['mybarts'];
				}else{
					gel('fpath').innerHTML = cat.path;
				}
			}
				
			if (!L.isNull(this.newBarterWidget)){
				this.newBarterWidget.category.setValue(catid);
			}
			
			Dom.setStyle(gel('fload'), 'display', '');
			
			var cfg = {'catid': catid};

			NS.barterManager.loadList(cfg, function(list){
				Dom.setStyle(TM.getEl('widget.fload'), 'display', 'none');
				if (list.cfg != cfg){ return; }
				
				__self.renderList(list);
			});
		},
		loadMore: function(){
			var __self = this,
				TM = this._TM, gel = function(nm){ return TM.getEl('widget.'+nm); };
			
			Dom.setStyle(gel('bloadmore'), 'display', 'none');
			Dom.setStyle(gel('ploadmore'), 'display', '');
			
			var list = this.currentList;
			NS.barterManager.loadMoreList(list, function(){
				Dom.setStyle(gel('bloadmore'), 'display', '');
				Dom.setStyle(gel('ploadmore'), 'display', 'none');
				__self.renderList(list);
			});
		}
		
	};
	NS.BarterListWidget = BarterListWidget;
};