/*
@version $Id: bartview.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	mod:[
		{name: '{C#MODNAME}', files: ['bartlib.js', 'barteditor.js', 'scopeview.js', 'categorylist.js']}
	]
};
Component.entryPoint = function(NS){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var UID = Brick.env.user.id*1;
	
	var LNG = Brick.util.Language.geta(['mod', '{C#MODNAME}']);
	
	var TMG = this.template,
		initCSS = false,
		buildTemplate = function(w, ts){
		if (!initCSS){
			Brick.util.CSS.update(Brick.util.CSS['{C#MODNAME}']['{C#COMNAME}']);
			delete Brick.util.CSS['{C#MODNAME}']['{C#COMNAME}'];
			initCSS = true;
		}
		w._TM = TMG.build(ts); w._T = w._TM.data; w._TId = w._TM.idManager;
		return w._TM;
	};
	
	var BarterRowWidget = function(container, bart){
		this.init(container, bart);
	};
	BarterRowWidget.prototype = {
		init: function(container, bart){
			this.barter = bart;
			buildTemplate(this, 'row,rowview,bedit,rowcat,user');
			
			container.innerHTML += this._TM.replace('row');
			this.render();
			this.editorWidget = null;
			this.scopeWidget = null;
		},
		destroy: function(){
			if (!L.isNull(this.editorWidget)){
				this.editorWidget.destroy();
			}
		},
		onClick: function(el){
			if (!L.isNull(this.scopeWidget)){
				if (this.scopeWidget.onClick(el)){ return true; }
			}
			
			var TId = this._TId;
			switch(el.id){
			case TId['rowview']['bshowscope']: this.showScopeWidget(); return true;
			case TId['bedit']['bedit']: this.showEditorWidget(); return true;
			}
			return false;
		},
		render: function(){
			var TM = this._TM,
				bart = this.barter,
				cat = NS.jobManager.categoryFind(bart.catid);

			TM.getEl('row.view').innerHTML = TM.replace('rowview', {
				'id': bart.id,
				'title': bart.title,
				'uriview': NS.navigator.barter.view(bart.id),
				'bedit': Brick.env.user.id != bart.userid ? '' : TM.replace('bedit'),
				'pdt': bart.pubdate>0 && !bart.isdraft ? Brick.dateExt.convert(bart.pubdate) : LNG['draft'],
				'cat': L.isNull(cat) ? '' : TM.replace('rowcat', {'path': cat.path}),
				'anscnt': bart.answerCount, 
				'desc': bart.descript
			});
		},
		
		showScopeWidget: function(){
			var TM = this._TM;
			if (L.isNull(this.scopeWidget)){
				this.scopeWidget = new NS.ScopeListWidget(TM.getEl('rowview.scopelist'), this.barter.userid);
			}
			Dom.addClass(TM.getEl('rowview.bshowscope'), 'hide');
			Dom.removeClass(TM.getEl('rowview.scope'), 'hide');
		},
		showEditorWidget: function(){
			if (!L.isNull(this.editorWidget)){ return; }
			
			var __self = this,
				bart = this.barter;
			
			var callback = function(tp, sd){
				__self.hideEditorWidget();
				if (tp == 'cancel'){
				}else if (tp == 'save'){
					__self.render();
				}
			};
			this.editorWidget = new NS.BarterEditorWidget(this._TM.getEl('row.editor'), bart, callback);
			Dom.setStyle(this._TM.getEl('row.view'), 'display', 'none');
		},
		hideEditorWidget: function(){
			this.editorWidget = null;
			Dom.setStyle(this._TM.getEl('row.view'), 'display', '');
		}
	};
	NS.BarterRowWidget = BarterRowWidget;
	
	var BarterInfoWidget = function(container, bart){
		this.init(container, bart);
	};
	BarterInfoWidget.prototype = {
		init: function(container, bart){
			var TM = buildTemplate(this, 'pinfo,user');
			var user = NS.jobManager.users.get(bart.userid);
			container.innerHTML = TM.replace('pinfo',{
				'user': TM.replace('user', {
					'uid': user.id,
					'unm':  user.getUserName()
				})
			});
		},
		destroy: function(){},
		onClick: function(el){
			return false;
		}
	};
	NS.BarterInfoWidget = BarterInfoWidget;
	
	var BAnswerEditWidget = function(container, answer, callback){
		this.init(container, answer, callback);
	};
	BAnswerEditWidget.prototype = {
		init: function(container, answer, callback){
			this.answer = answer;
			this.callback = callback;
			
			var TM = buildTemplate(this, 'ansedit'),
				gel = function(n){ return TM.getEl('ansedit.'+n); };
			container.innerHTML = TM.replace('ansedit');
			
			this.scopeWidget = new NS.ScopeListWidget(gel('scope'));

		},
		destroy: function(){},
		onClick: function(el){
			if (this.scopeWidget.onClick(el)){ return true; }
			
			if (el.id == this._TId['ansedit']['bsave']){
				this.save();
				return true;
			}
			return false;
		},
		save: function(){
			if (!L.isFunction(this.callback)){ return; }
			var TM = this._TM, gel = function(n){ return TM.getEl('ansedit.'+n); };
			Dom.setStyle(gel('bsave'), 'display', 'none');
			Dom.setStyle(gel('saveproc'), 'display', '');
			this.callback({
				'dsc':  L.trim(gel('descript').value),
				'prv': gel('private').checked ? 1 : 0
			});
		}
	};
	NS.BAnswerEditWidget = BAnswerEditWidget;
	
	var BAnswerRowWidget = function(container, answer){
		this.init(container, answer);
	};
	BAnswerRowWidget.prototype = {
		init: function(container, ans){
			this.answer = ans;
			this.scopeWidget = null;
			var TM = buildTemplate(this, 'ansrow,user'),
				gel = function(n){ return TM.getEl('ansrow.'+n); };

			var user = NS.jobManager.users.get(ans.userid);
			container.innerHTML += TM.replace('ansrow', {
				'avatar': user.avatar45(),
				'user': TM.replace('user', {
					'uid': user.id,
					'unm':  user.getUserName()
				}),
				'dl': Brick.dateExt.convert(ans.date)
			});
			gel('dsc').innerHTML = ans.descript;
			this.renderCommentCount();
		},
		destroy: function(){
			var el = this._TM.getEl('ansrow.id');
			el.parentNode.removeChild(el);
			this.answer = null;
		},
		renderCommentCount: function(){
			this._TM.getEl('ansrow.ccnt').innerHTML = this.answer.commentCount;
		},
		enableComment: function(){
			Dom.removeClass(this._TM.getEl('ansrow.cmtbox'), 'hide');
		},
		onClick: function(el){
			if (!L.isNull(this.scopeWidget)){
				if (this.scopeWidget.onClick(el)){ return true; }
			}
			
			var tp = this._TId['ansrow'];
			switch(el.id){
			case tp['bshow']: this.showCommentBox(); return true;
			case tp['bhide']: this.hideCommentBox(); return true;
			
			case tp['bshowscope']: this.showScopeWidget(); return true;
			
			}
			return false;
		},
		hideCommentBox: function(){
			Dom.replaceClass(this._TM.getEl('ansrow.cmtbox'), 'pashst', 'pahdst');
		},
		showCommentBox: function(){
			var ans = this.answer,
				TM = this._TM,
				gel = function(n){ return TM.getEl('ansrow.'+n); };
			
			Dom.replaceClass(gel('cmtbox'), 'pahdst', 'pashst');
			
			if (this._startld){ return; }
			this._startld = true;
			
			// Инициализировать менеджер комментариев
			Brick.ff('comment', 'comment', function(){
				Brick.mod.comment.API.buildCommentTree({
					'container': gel('cmt'),
					'dbContentId': ans.commentid,
					'config': {
						'onLoadComments': function(){
							// aTargetBlank(TM.getEl('panel.taskbody'));
							// aTargetBlank(TM.getEl('panel.comments'));
						}
						// ,
						// 'readOnly': barter.w*1 == 0,
						// 'manBlock': L.isFunction(config['buildManBlock']) ? config.buildManBlock() : null
					},
					'instanceCallback': function(b){ }
				});
			});
		},
		showScopeWidget: function(){
			var TM = this._TM;
			if (L.isNull(this.scopeWidget)){
				this.scopeWidget = new NS.ScopeListWidget(TM.getEl('ansrow.scopelist'), this.answer.userid);
			}
			Dom.addClass(TM.getEl('ansrow.bshowscope'), 'hide');
			Dom.removeClass(TM.getEl('ansrow.scope'), 'hide');
		}		
	};
	NS.BAnswerRowWidget = BAnswerRowWidget;
	
	var BAnswerListWidget = function(container, barter){
		this.init(container, barter);
	};
	BAnswerListWidget.prototype = {
		init: function(container, barter){
			this.barter = barter;
			var TM = buildTemplate(this, 'anslist,ansrowempty');
			container.innerHTML = TM.replace('anslist');
			
			this.elList = TM.getEl('anslist.id');
			
			this.ws = [];
			this.render();
		},
		destroy: function(){
			this.clearws();
		},
		clearws: function(){
			for (var i=0;i<this.ws.length;i++){
				this.ws[i].destroy();
			}
			this.ws = [];
			this.elList.innerHTML = "";
		},
		renderRow: function(ans){
			var p = this.barter,
				w = new NS.BAnswerRowWidget(this.elList, ans);
			
			if (UID == p.userid || UID == ans.userid){
				w.enableComment();
			}
			
			this.ws[this.ws.length] = w;
		},
		render: function(){
			this.clearws();
			var __self = this;
			this.barter.answers.foreach(function(ans){
				__self.renderRow(ans);
			});
			if (this.ws.length == 0){
				this.elList.innerHTML = this._TM.replace('ansrowempty');
			}
		},
		onClick: function(el){
			for (var i=0;i<this.ws.length;i++){
				this.ws[i].onClick(el);
			}
			return false;
		}
	};
	NS.BAnswerListWidget = BAnswerListWidget;
	
	
	var BarterViewWidget = function(container, bartid, callback){
		this.init(container, bartid, callback);
	};
	BarterViewWidget.prototype = {
		init: function(container, bartid, callback){
			var TM = buildTemplate(this, 'widget'), __self = this;
			container.innerHTML = TM.replace('widget');

			this.ws = {};
			
			NS.barterManager.barterLoad(bartid, function(bart){
				__self.onLoadBarter(bart);
				if (L.isFunction(callback)){
					callback(bart);
				}
			});
		},
		destroy: function(){
			for (var n in this.ws){
				this.ws[n].destroy();
			}
		},
		onLoadBarter: function(bart){
			this.barter = bart;
			var ws = this.ws, __self = this, 
				TM = this._TM, gel = function(n){ return TM.getEl('widget.'+n); };
			
			ws['bartrow'] = new NS.BarterRowWidget(gel('bart'), bart);
			ws['bartinfo'] = new NS.BarterInfoWidget(gel('pinfo'), bart);
			
			var userid = Brick.env.user.id*1,
				showNewAnswer = bart.userid != userid;
			
			if (showNewAnswer){
				bart.answers.foreach(function(ans){
					if (ans.userid == userid){
						showNewAnswer = false;
						return;
					}
				});
			}
			
			if (showNewAnswer){
				ws['ansnew'] = new NS.BAnswerEditWidget(gel('ansedit'), new NS.BAnswer(), function(d){
					__self.onAnswerAppend(d);
				});
			}
			ws['anslist'] = new NS.BAnswerListWidget(gel('anslist'), bart);

			E.on(TM.getEl('widget.id'), 'click', function(e){
				var el = E.getTarget(e);
				if (__self.onClick(el)){ E.preventDefault(e); }
			});
		},
		onClick: function(el){
			for (var n in this.ws){
				if (this.ws[n].onClick(el)){
					return true;
				}
			}
			return false;
		},
		onAnswerAppend: function(sd){
			var __self = this, TM = this._TM, ws = this.ws;
			
			NS.barterManager.answerAppend(this.barter.id, sd, function(r){
				Dom.setStyle(TM.getEl('widget.ansedit'), 'display', 'none');
				ws['anslist'].render();
			});
		}
	};
	NS.BarterViewWidget = BarterViewWidget;
	
};