/*
@version $Id: categoryman.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	mod:[
        {name: '{C#MODNAME}', files: ['categorylist.js']}
	]
};
Component.entryPoint = function(NS){
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var buildTemplate = this.buildTemplate;
	
	var CategoryEditorWidget = function(container, catid, pcatid){
		pcatid = pcatid || 0;
		this.init(container, catid, pcatid);
	};
	CategoryEditorWidget.prototype = {
		init: function(container, catid, pcatid){
			var TM = buildTemplate(this, 'edit'),
				gel = function(n){ return TM.getEl('edit.'+n);};
			
			container.innerHTML = TM.replace('edit', {
				'status': catid>0 ? 'stedit' : 'stnew'
			});
			this.parentWidget = new NS.CategorySelectWidget(gel('parent'), 0, {
				'notgroup': true
			});
			
			var cat;
			if (catid > 0){
				cat = NS.jobManager.categoryFind(catid);
				pcatid = cat.parentid;
			}else{
				cat = new NS.Category();
			}
			
			this.parentWidget.setValue(pcatid);

			gel('stitle').innerHTML = cat.title;
			gel('title').value = cat.title;
			gel('ord').value = cat.ord;
			
			this.category = cat;
			this._isdestroy = false;
		},
		destroy: function(){
			if (this._isdestroy){ return; }
			this._isdestroy = true;

			var el = this._TM.getEl('edit.id');
			el.parentNode.removeChild(el);
		},
		onClick: function(el){
			var tp = this._TId['edit'];
			switch(el.id){
			case tp['bsave']: case tp['bappend']: 
				this.save(); return true;
			case tp['bremove']: this.remove();  return true;
			case tp['bcancel']: this.destroy();  return true;
			}
			
			return false;
		},
		remove: function(){
			var __self = this, catid = this.category.id;
			new CategoryRemovePanel(catid, function(){
				__self._ajax({
					'do': 'categoryremove',
					'id': catid
				});
				__self.destroy();
			});
		},
		save: function(){
			var TM = this._TM, gel = function(n){ return TM.getEl('edit.'+n);},
				__self = this, catid = this.category.id;
			this._ajax({
				'do': 'categorysave',
				'id': catid,
				'pid': this.parentWidget.getValue(),
				'tl': gel('title').value,
				'o': gel('ord').value
			}, function(){
				if (catid == 0){
					__self.destroy();
				}
			});
		},
		_ajax: function(sd, callback){
			var TM = this._TM, gel = function(n){ return TM.getEl('edit.'+n);};
			
			Dom.setStyle(gel('btns'), 'display', 'none');
			Dom.setStyle(gel('loading'), 'display', '');
			
			NS.jobManager.ajax(sd, function(d){
				Dom.setStyle(gel('btns'), 'display', '');
				Dom.setStyle(gel('loading'), 'display', 'none');
				
				NS.jobManager._updateCategoryList(d);
				NS.jobManager.onCategoryChanged();
				NS.life(callback);
			});
		}
	};
	NS.CategoryEditorWidget = CategoryEditorWidget;
	
	var CategoryRemovePanel = function(catid, callback){
		this.catid = catid*1;
		this.callback = callback;
		CategoryRemovePanel.superclass.constructor.call(this, {
			'width': '400px'
		});
	};
	YAHOO.extend(CategoryRemovePanel, Brick.widget.Dialog, {
		initTemplate: function(){
			var cat = NS.jobManager.categoryFind(this.catid);
			return buildTemplate(this, 'removepanel').replace('removepanel', {
				'tl': cat.title
			});
		},
		onClick: function(el) {
			var tp = this._TId['removepanel'];
			switch(el.id){
			case tp['bcancel']: this.close(); return true;
			case tp['bremove']: this.close(); this.callback(); return true;
			}
			return false;
		}
	});
    NS.CategoryRemovePanel = CategoryRemovePanel;

	var CategoryManagerWidget = function(container){
		this.init(container);
	};
	CategoryManagerWidget.prototype = {
		init: function(container){
			var TM = buildTemplate(this, 'widget');
			container.innerHTML = TM.replace('widget');
			
			this.editorWidget = null;
			
			var __self = this;
			NS.API.initJobManager(function(){
				__self._onInitJobManager();
			});
			
			this.wsMenuItem = 'man';
			
			var __self = this;
			E.on(container, 'click', function(e){
				var el = E.getTarget(e);
				if (__self.onClick(el)){ E.preventDefault(e); }
			});
		},
		destroy: function(){
			if (this.catsWidget){
				this.catsWidget.clickItemEvent.unsubscribe(this.onCatalogClickItem);
				this.catsWidget.destroy();
			}
		},
		_onInitJobManager: function(){
			var TM = this._TM;
			this.catsWidget = new NS.CategoryColListWidget(TM.getEl('widget.list'));
			this.catsWidget.clickItemEvent.subscribe(this.onCatalogClickItem, this, true);
		},
		onClick: function(el){
			
			if (!L.isNull(this.editorWidget) && this.editorWidget.onClick(el)){
				return true;
			}
			var tp = this._TId['widget'];
			switch(el.id){
			case tp['baddcat']:
				this.setCategoryId(0);
				return true;
			}
			
			return false;
		},
		onCatalogClickItem: function(evt, prm){
			this.setCategoryId(prm[0]);
		},
		setCategoryId: function(catid){
			
			if (!L.isNull(this.editorWidget)){
				this.editorWidget.destroy();
			}
			
			this.editorWidget = new CategoryEditorWidget(this._TM.getEl('widget.editor'), catid);
		}
	};
	NS.CategoryManagerWidget = CategoryManagerWidget;
	
};