/*
@version $Id: home.js 1548 2012-05-03 09:09:38Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	mod:[
		{name: '{C#MODNAME}', files: ['projlist.js', 'bartlist.js']}
	]
};
Component.entryPoint = function(NS){

	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang,
		R = NS.roles;

	
	var buildTemplate = this.buildTemplate;
	
	var HomeWidget = function(container){
		this.init(container);
	};
	HomeWidget.prototype = {
		init: function(container){
			buildTemplate(this, 'widget,empty');
			container.innerHTML = this._TM.replace('widget');
			
			var d = {
				'ismain': L.isNull(NS.jobManager),
				'isproject': true,
				'isbarter': true
			};
			var __self = this;
			Brick.ajax('{C#MODNAME}', {
				'data': {'do': 'home', 'load': d},
				'event': function(request){
					__self.onLoadData(request.data);
				}
			});
			
			var __self = this;
			E.on(container, 'click', function(e){
				var el = E.getTarget(e);
				if (__self.onClick(el)){ E.preventDefault(e); }
			});
		},
		destroy: function(){
			var el = this._TM.getEl('widget.id');
			el.parentNode.removeChild(el);
		},
		onLoadData: function(data){
			if (L.isNull(NS.jobManager)){
				NS.jobManager = new NS.JobManager(null, data['category']);
			}

			NS.API.initProjectManager();
			var projList = NS.projectManager.buildList({}, data['project']);

			NS.API.initBarterManager();
			var bartList = new NS.barterManager.buildList({}, data['barter']);
			
			var TM = this._TM, gel = function(nm){ return TM.getEl('widget.'+nm); };

			var arr = [];
			projList.foreach(function(proj){
				arr[arr.length] = proj;
			});
			bartList.foreach(function(bart){
				arr[arr.length] = bart;
			});
			
			arr = arr.sort(function(p1, p2){
				if (p1.pubdate > p2.pubdate){ return -1; }
				if (p1.pubdate < p2.pubdate){ return 1; }
				return 0;
			});
			var wList = [], container = gel('list');
			container.innerHTML = '';

			for (var i=0;i<arr.length;i++){
				var p = arr[i];
				if (p.type == 'barter'){
					wList[wList.length] = new NS.BarterRowWidget(container, p);
				}else if (p.type == 'project'){
					wList[wList.length] = new NS.ProjectRowWidget(container, p);
				}
			}
			this._wList = wList;
			
			if (wList.length == 0){
				container.innerHTML = TM.replace('empty');
			}
		},
		_wlForeach: function(f){ for (var i=0;i<this._wList.length;i++){ f(this._wList[i]); } },
		_wlClear: function(){ this._wlForeach(function(w){ w.destroy(); }); },
		onClick: function(el){
			this._wlForeach(function(w){
				w.onClick(el);
			});
			return false;
		}
	};
	NS.HomeWidget = HomeWidget;

};