/*
@version $Id: lib.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = { 
	mod:[
        {name: 'sys', files: ['item.js','number.js']},
        {name: 'uprofile', files: ['users.js']},
        {name: '{C#MODNAME}', files: ['roles.js']}
	]		
};
Component.entryPoint = function(NS){

	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang,
		R = NS.roles;

	var SysNS = Brick.mod.sys;
	var UP = Brick.mod.uprofile;
	
	Brick.util.CSS.update(Brick.util.CSS['{C#MODNAME}']['{C#COMNAME}']);
	delete Brick.util.CSS['{C#MODNAME}']['{C#COMNAME}'];
	var TMG = this.template, buildTemplate = function(w, ts){w._TM = TMG.build(ts); w._T = w._TM.data; w._TId = w._TM.idManager;};
	
	NS.lif = function(f){return L.isFunction(f) ? f : function(){}; };
	NS.life = function(f, p1, p2, p3, p4, p5, p6, p7){ 
		f = NS.lif(f); f(p1, p2, p3, p4, p5, p6, p7);
	};
	NS.textToEdit = function(s){
		return s.replace(/<br\/>/gi, '');
	};
	
	NS.Item = SysNS.Item;
	NS.ItemList = SysNS.ItemList;
	
	var Category = function(d){
		d = L.merge({
			'pid': 0,	// parentid
			'tl': '',	// title
			'p': 0,		// project count
			'o': 0
		}, d || {});
		Category.superclass.constructor.call(this, d);
	};
	YAHOO.extend(Category, NS.Item, {
		update: function(d){
			this.parentid = d['pid']*1;
			this.title = d['tl'];
			this.path = d['tl'];
			
			this.projCount = d['p']*1;
			this.ord = d['o']*1;
			
			this.childList = null;
		},
		addChild: function(category){
			if (L.isNull(this.childList)){
				this.childList = new CategoryList();
			}
			this.childList.add(category);
			category.path = this.path + "/" + category.path;
		},
		foreach: function(f){
			if (L.isNull(this.childList)){ return; }
			this.childList.foreach(f);
		}
	});
	NS.Category = Category;
	
	var CategoryList = function(d){
		CategoryList.superclass.constructor.call(this, d, Category);
	};
	YAHOO.extend(CategoryList, NS.ItemList, {});
	NS.CategoryList = CategoryList;
	
	var JobManager = function(callback, data){
		this.init(callback, data);
	};
	JobManager.prototype = {
		init: function(callback, data){
		
			var __self = this;
			
			this.categoryChangedEvent = new YAHOO.util.CustomEvent("categoryChangedEvent");
			this.categoryCountChangedEvent = new YAHOO.util.CustomEvent("categoryCountChangedEvent");

			this.categoryList = new CategoryList();
			this.users = Brick.mod.uprofile.viewer.users;
			
			if (data){
				this._updateCategoryList(data);
			}else{
				R.load(function(){
					__self.ajax({'do': 'categorylist'}, function(data){
						if (!L.isNull(data)){
							__self._updateCategoryList(data);
						}
						NS.life(callback, __self);
					});
				});
			}
		},
		ajax: function(data, callback){
			Brick.ajax('{C#MODNAME}', {
				'data': data,
				'event': function(request){
					if (L.isFunction(callback)){
						callback(request.data);
					}
				}
			});
		},
		onCategoryChanged: function(){
			this.categoryChangedEvent.fire();
		},
		onCategoryCountChanged: function(){
			this.categoryCountChangedEvent.fire();
		},
		updateCatProjCount: function(d){
			if (!d){ return; }
			this.categoryForeach(function(cat){
				cat.projCount = d[cat.id]*1;
			});
			this.onCategoryCountChanged();
		},
		categoryForeach: function(f, onlyChild){
			if (!L.isFunction(f)){ return; }
			var ret = false;
			this.categoryList.foreach(function(cat){
				if (ret){ return true; }
				if (!onlyChild){
					if (f(cat)){ return true; }
				}
				cat.foreach(function(fcat){
					if (f(fcat)){
						ret = true;
						return true; 
					}
				});
			});
		},
		categoryFind: function(catid){
			var find = null;
			
			this.categoryList.foreach(function(cat){
				if (!L.isNull(find)){ return true; }
				if (cat.id == catid){ 
					find = cat;
					return true;
				}
				cat.foreach(function(fcat){
					if (fcat.id == catid){ 
						find = fcat;
						return true;
					}
				});
			});
			
			return find;
		},
		_updateCategoryList: function(d){
			if (L.isNull(d)){ return; }
			this.categoryList.clear();
			var ta = [];
			for (var i=0;i<d.length;i++){
				var di = d[i],
					cat = new NS.Category(di);
				
				if (cat.parentid == 0){
					this.categoryList.add(cat);
				}else{
					ta[ta.length] = cat;
				}
			}
			for (var i=0;i<ta.length;i++){
				var cat = ta[i];
				
				var pcat = this.categoryList.get(cat.parentid);
				if (!L.isNull(pcat)){
					pcat.addChild(cat);
				}
				
			}
		}
	};
	NS.JobManager = JobManager;
	NS.jobManager = null;
	
	NS.API.initJobManager = function(callback){
		if (L.isNull(NS.jobManager)){
			NS.jobManager = new JobManager(callback);
		}else{
			NS.life(callback, NS.jobManager);
		}
	};
	
	
	NS.formatCost = function(cost, curr){
		cost = YAHOO.util.Number.format(cost, {
			'thousandsSeparator': ' ',
			'decimalPlaces': 0
		});
		switch(curr*1){
		case 1: return cost+" p.";
		case 2: return "$ "+cost;
		case 3: return cost+" €";
		}
		return cost;
	};
	
	YAHOO.util.Number.format.defaults = {
	    decimalSeparator : '.',
	    decimalPlaces    : null,
	    thousandsSeparator : '',
	    prefix : '',
	    suffix : '',
	    negativeFormat : '-#'
	};
	
	var WS = "#app={C#MODNAMEURI}/wspace/ws/",
		PWS = WS+'project/ProjectWorkspaceWidget/',
		BWS = WS+'barter/BarterWorkspaceWidget/';
	
	NS.navigator = {
		'home': WS, 
		'project': {
			'list': function(filter){
				return PWS+(filter ? 'list/'+filter+'/' : '');
			},
			'my': function(){
				return PWS+'list/my';	
			},
			'view': function(projid){
				return PWS+'view/'+projid;
			}
		},
		'barter': {
			'list': function(filter){
				return BWS+(filter ? 'list/'+filter+'/' : '');
			},
			'my': function(){
				return BWS+'list/my';	
			},
			'view': function(projid){
				return BWS+'view/'+projid;
			}
		},
		'category': {
			'manager': function(){
				return WS+'categoryman/CategoryManagerWidget/';
			}
		},
		'about': function(){
			return WS+'about/AboutWidget/';
		}
	};

};