/*
@version $Id: project.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	mod:[
		{name: '{C#MODNAME}', files: ['projlib.js', 'categorylist.js']}
	]
};
Component.entryPoint = function(NS){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var buildTemplate = this.buildTemplate;
	
	var ProjectWorkspaceWidget = function(container, act, p){
		this.init(container, act, p);
	};
	ProjectWorkspaceWidget.prototype = {
		init: function(container, act, p){
			
			this._action = act;
			this._actparam = p;
			
			var TM = buildTemplate(this, 'widget');
			container.innerHTML = TM.replace('widget');

			this.catsWidget = null;
			this.ws = {};
			
			var __self = this;
			NS.API.initProjectManager(function(man){
				__self.setGlobalParam(__self._action, __self._actparam);
			});
			
			this.wsMenuItem = p == 'my' ? 'my' : 'list';
		},
		setGlobalParam: function(act, p){
			this._action = act;
			this._actparam = p || 0;
			
			if (L.isNull(NS.projectManager)){
				// идет загрузка PM, ждем, после загрузки вызовет этот метод
				return;
			}
			
			var gAct = this._action, gPrm = this._actparam;

			var __self = this,
				ws = this.ws,
				TM = this._TM,
				gel = function(nm){ return TM.getEl('widget.'+nm); },
				setStyle = function(nm, v){ Dom.setStyle(gel(nm), 'display', v); };

			setStyle('loading', 'none');
			setStyle('page', '');

			if (L.isNull(this.catsWidget)){
				this.catsWidget = new NS.CategoryColListWidget(gel('catlist'));
				this.catsWidget.selectChangedEvent.subscribe(this.onCatalogChaged, this, true);
			}

			var showLoading = function(wn){
				setStyle('mloading', '');
				setStyle('content', 'none');
			};
			var hideLoading = function(wn){
				setStyle('mloading', 'none');
				setStyle('content', '');
				for (var n in ws){setStyle(n,wn==n?'':'none');}
			};
			
			switch(gAct){
			case 'view': 
				var showProjView = function(){
					if (ws['projview']){
						ws['projview'].destroy();
					}
					ws['projview'] = new NS.ProjectViewWidget(gel('projview'), gPrm, function(proj){
						hideLoading('projview');
						if (!L.isNull(proj)){
							__self.setCatalogId(proj.catid);
						}
					});
				};
				if (!ws['projview']){
					showLoading();
					Brick.ff('{C#MODNAME}', 'projview', showProjView);
				}else{
					showProjView();
				}
				break;
			default:
				var catid = gPrm;
			
				if (!ws['projlist']){
					showLoading();
					Brick.ff('{C#MODNAME}', 'projlist', function(){
						ws['projlist'] = new NS.ProjectListWidget(gel('projlist'), catid);
						hideLoading('projlist');
					});
				}else{
					ws['projlist'].setConfig(catid);
					hideLoading('projlist');
				}
				this.setCatalogId(catid);
				break;
			}
		},
		onCatalogChaged: function(){
			if (this._blockCatsWEvent){ return; }

			var catid = this.catsWidget.getValue();
			Brick.Page.reload(NS.navigator.project.list(catid));
		},
		setCatalogId: function(catid){
			this._blockCatsWEvent = true;
			this.catsWidget.setValue(catid);
			this._blockCatsWEvent = false;
		},
		destroy: function(){
			if (!L.isNull(this.catsWidget)){
				this.catsWidget.selectChangedEvent.unsubscribe(this.onCatalogChaged);
			}
		}
	};
	NS.ProjectWorkspaceWidget = ProjectWorkspaceWidget;
	
};