/*
@version $Id: projlib.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = { 
	mod:[
        {name: '{C#MODNAME}', files: ['lib.js']}
	]		
};
Component.entryPoint = function(NS){

	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang,
		R = NS.roles;

	var Project = function(d){
		d = L.merge({
			'catid': 0,
			'uid': 0,
			'tl': '',
			'dsc': '',
			'argm': 0,
			'cst': 0,
			'cctp': 0,
			'pctp': 0,
			'dft': 0,
			'pdt': 0,
			'acnt': 0
		}, d || {});
		Project.superclass.constructor.call(this, d);
	};
	YAHOO.extend(Project, NS.Item, {
		init: function(d){
			this.answers = new PAnswerList();
			
			Project.superclass.init.call(this, d);
		},
		update: function(d){
			this.type = 'project';
			this.catid = d['catid']*1;
			this.userid = d['uid']*1;
			this.title = d['tl'];
			this.descript = d['dsc'];
			this.agreement = d['agr']>0;
			this.cost = d['cst']*1;
			this.currency = d['cctp']*1;
			this.priceby = d['pctp']*1;
			this.isdraft = d['dft']*1 > 0;
			this.pubdate = d['pdt']*1;
			this.answerCount = d['acnt']*1;
			
			this.answers.clear();
			this.answers.update(d['answers']);
		}
	});
	NS.Project = Project;
	
	var ProjectList = function(cfg){
		this.cfg = cfg || null;
		this.dbCount = null;
		
		ProjectList.superclass.constructor.call(this, [], Project);
	};
	YAHOO.extend(ProjectList, NS.ItemList, {});
	NS.ProjectList = ProjectList;

	var PAnswer = function(d){
		d = L.merge({
			'pid': 0, 'uid': 0, 'dsc': '', 'prv': 0,
			'bcost': 0, 'ecost': 0, 'ctp': 1,
			'btm': 0, 'etm': 0, 'ttm': 1,
			'dl': 0, 'ctid': 0, 'ccnt': 0
		}, d || {});
		PAnswer.superclass.constructor.call(this, d);
	};
	YAHOO.extend(PAnswer, NS.Item, {
		update: function(d){
			this.userid = d['uid']*1;
			this.projectid = d['pid'];
			
			this.bCost = d['bcost']*1;
			this.eCost = d['ecost']*1;
			this.tCost = d['ctp']*1;
			
			this.bTime = d['btm']*1;
			this.eTime = d['etm']*1;
			this.tTime = d['ttm']*1;
			
			this.descript = d['dsc'];
			this.isPrivate = d['prv']*1>0;
			this.date = d['dl']*1;
			this.commentid = d['ctid'];
			this.commentCount = d['ccnt'];
		}
	});
	NS.PAnswer = PAnswer;

	var PAnswerList = function(d){
		PAnswerList.superclass.constructor.call(this, d, PAnswer);
	};
	YAHOO.extend(PAnswerList, NS.ItemList, {});
	NS.PAnswerList = PAnswerList;
	
	var ProjectManager = function(callback){
		this.init(callback);
	};
	ProjectManager.prototype = {
		init: function(callback){
			NS.projectManager = this;
			
			// список просматриваемых проектов
			this.projectList = new ProjectList();

			var __self = this;
			NS.API.initJobManager(function(){
				NS.life(callback, __self);
			});
		},
		ajax: function(data, callback){
			data['type'] = 'project';
			NS.jobManager.ajax(data, callback);
		},
		buildList: function(cfg, d){
			var list = new NS.ProjectList(cfg);
			if (!L.isNull(d)){
				list.dbCount = d['fcnt'];
				list.update(d['list']);
				NS.jobManager.updateCatProjCount(d['pcnt']);
			}
			return list;
		},
		loadList: function(cfg, callback){
			if (!L.isFunction(callback)){ return; }
			
			var __self = this;
			this.ajax({
				'do': 'projectlist',
				'catid': cfg['catid']
			}, function(d){
				var list = __self.buildList(cfg, d);
				callback(list);
			});
		},
		loadMoreList: function(list, callback){
			if (!L.isFunction(callback)){ return; }
			this.ajax({
				'do': 'projectlist',
				'catid': list.cfg['catid'],
				'next':list.count()
			}, function(d){
				if (!L.isNull(d)){
					list.update(d['list']);
				}
				callback();
			});
		},
		projectSave: function(sd, callback){
			sd['do'] = 'projectsave';
			this.ajax(sd, function(d){
				if (L.isFunction(callback)){
					callback(d);
				}
			});
		},
		_projectResult: function(d){
			if (L.isNull(d)){ return null; }
				
			var proj = this.projectList.get(d['p']['id']);
			if (L.isNull(proj)){
				proj = new NS.Project(d['p']);
				this.projectList.add(proj);
			}else{
				proj.update(d['p']);
			}
			NS.jobManager.updateCatProjCount(d['pcnt']);
			NS.jobManager.users.update(d['users']);
			return proj;
		},
		projectLoad: function(projid, callback){
			var __self = this;
			this.ajax({
				'do': 'project',
				'projid': projid
			}, function(d){
				
				var proj = __self._projectResult(d);
				
				if (L.isFunction(callback)){ 
					callback(proj);
				}
			});
		},
		answerAppend: function(projid, sd, callback){
			var __self = this;
			this.ajax({
				'do': 'answerappend',
				'projid': projid,
				'answer': sd
			}, function(d){
				
				d['proj'] = __self._projectResult(d['project']);
				
				if (L.isFunction(callback)){ 
					callback(d);
				}
			});
		}
	};
	NS.ProjectManager = ProjectManager;
	NS.projectManager = null;
	
	NS.API.initProjectManager = function(callback){
		if (L.isNull(NS.projectManager)){
			NS.projectManager = new ProjectManager(callback);
		}else{
			NS.life(callback, NS.projectManager);
		}
	};

};