/*
@version $Id: scopedit.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	mod:[
		{name: '{C#MODNAME}', files: ['categorylist.js', 'scopelib.js']}
	]
};
Component.entryPoint = function(NS){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var R = NS.roles;
	
	var buildTemplate = this.buildTemplate;

	var ScopeCatRowWidget = function(container, scope){
		this.init(container, scope);
	};
	ScopeCatRowWidget.prototype = {
		init: function(container, scope){
			this.scope = scope;
			
			var cat = NS.jobManager.categoryFind(scope.catid),
				ptl = '!!!', tl = '!!!';
			
			if (!L.isNull(cat)){
				tl = cat.title;
				var pcat = NS.jobManager.categoryFind(cat.parentid);
				if (!L.isNull(pcat)){
					ptl = pcat.title;
				}					
			}

			buildTemplate(this, 'catrow');
			container.innerHTML = this._TM.replace('catrow', {
				'ptl': ptl,
				'tl': tl,
				'dsc': NS.textToEdit(scope.descript)
			}) + container.innerHTML;
			this.fixedsv();
			
			this._isRemoved = false;
		},
		destroy: function(){},
		onClick: function(el){
			var tp = this._TId['catrow'];
			switch(el.id){
			case tp['bremove']: this.remove(true); return true;
			case tp['brestore']: this.remove(false); return true;
			}
			return false;
		},
		remove: function(removed){
			this._isRemoved = removed;
			
			var TM = this._TM, gel = function(nm){ return TM.getEl('catrow.'+nm); };
			if (removed){
				Dom.addClass(gel('tl'), 'removed');
				Dom.addClass(gel('bremove'), 'hide');
				Dom.removeClass(gel('brestore'), 'hide');
			} else {
				Dom.removeClass(gel('tl'), 'removed');
				Dom.removeClass(gel('bremove'), 'hide');
				Dom.addClass(gel('brestore'), 'hide');
			}
		},
		fixedsv: function(){
			this._sd = this.getSaveData();
		},
		fixedupd: function(){
			this._TM.getEl('catrow.dsc').value = this._sd['dsc'];
		},
		getSaveData: function(){
			var d = {
				'id': this.scope.id,
				'catid': this.scope.catid,
				'dsc': this._TM.getEl('catrow.dsc').value,
				'f': this._isRemoved ? 'd' : ''
			};
			return d;
		},
		focus: function(){
			var el = this._TM.getEl('catrow.dsc');
			try{
				el.focus();
			}catch(e){}
		}
	};
	NS.ScopeCatRowWidget = ScopeCatRowWidget;
	
	var ScopeEditorWidget = function(container, scopeList, callback){
		this.init(container, scopeList, callback);
	};
	ScopeEditorWidget.prototype = {
		init: function(container, scopeList, callback){
			this.callback = callback;
			this._wList = [];
			
			buildTemplate(this, 'widget');
			var __self = this,
				TM = this._TM, gel = function(nm){ return TM.getEl('widget.'+nm); };
				
			container.innerHTML += TM.replace('widget');
			
			this.category = new NS.CategorySelectWidget(gel('catalog'));
			
			E.on(container, 'click', function(e){
				var el = E.getTarget(e);
				if (__self.onClick(el)){ E.preventDefault(e); }
			});
			
			var list = [];
			scopeList.foreach(function(scope){
				list[list.length] = scope;
			});
			this.list = list;
			this.renderList();
		},
		_wlForeach: function(f){ for (var i=0;i<this._wList.length;i++){ f(this._wList[i]); } },
		_wlClear: function(){ this._wlForeach(function(w){ w.destroy(); }); },
		_wlFixedSv: function(){ this._wlForeach(function(w){ w.fixedsv(); }); },
		_wlFixedUpd: function(){ this._wlForeach(function(w){ w.fixedupd(); }); },
		destroy: function(){
			this._wlClear();			
			
			var el = this._TM.getEl('widget.id');
			el.parentNode.removeChild(el);
		},
		onClick: function(el){
			this._wlForeach(function(w){
				w.onClick(el);
			});
			
			var tp = this._TId['widget'];
			switch(el.id){
			case tp['baddcat']: this.addCategory(this.category.getValue()); return true;
			case tp['bsave']: this.save(); return true;
			case tp['bcancel']: this.cancel(); return true;
			}
			return false;
		},
		addCategory: function(catid){
			if (catid*1 == 0){ return; }
			
			var lst = this.list, 
				wList = this._wList;
			for (var i=0;i<lst.length;i++){
				if (lst[i].catid == catid){
					for (var ii=0;ii<wList.length;ii++){
						if (wList[ii].scope.catid == catid){
							wList[ii].focus();
						}
					}
					return; 
				}
			}
			var scope = lst[lst.length] = new NS.Scope({'catid': catid}),
				container = this._TM.getEl('widget.list');
			
			this._wlFixedSv();
			var w = new NS.ScopeCatRowWidget(container, scope);
			wList[wList.length] = w;
			this._wlFixedUpd();
			w.focus();
		},
		renderList: function(){
			var TM = this._TM, gel = function(nm){ return TM.getEl('widget.'+nm); };

			var wList = this._wList, container = gel('list');
			this._wlClear();
			
			wList = [];
			container.innerHTML = '';
			for (var i=0;i<this.list.length;i++){
				wList[wList.length] = new NS.ScopeCatRowWidget(container, this.list[i]);
			}
			this._wList = wList;
		},
		getSaveData: function(){
			var d = [];
			this._wlForeach(function(w){
				d[d.length] = w.getSaveData();
			});
			return d;
		},
		cancel: function(){
			this.callback('cancel');
			this.destroy();
		},
		save: function(){
			var TM = this._TM, __self = this;
			
			var sd = {
				'list': this.getSaveData()
			};
			
			Dom.setStyle(TM.getEl('widget.btns'), 'display', 'none');
			Dom.setStyle(TM.getEl('widget.prcsave'), 'display', '');
			
			NS.scopeManager.listSave(sd, function(d){
				if (L.isNull(d)){
					__self.cancel();
				}else{
					__self.callback('save');
					__self.destroy();
				}
			});
		}
	};
	NS.ScopeEditorWidget = ScopeEditorWidget;
	
};