/*
@version $Id: scopelib.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = { 
	mod:[
        {name: '{C#MODNAME}', files: ['lib.js']}
	]		
};
Component.entryPoint = function(NS){

	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang,
		R = NS.roles;
	
	var Scope = function(d){
		d = L.merge({
			'catid': 0,
			'dsc': ''
		}, d || {});
		Scope.superclass.constructor.call(this, d);
	};
	YAHOO.extend(Scope, NS.Item, {
		update: function(d){
			this.catid = d['catid']*1;
			this.descript = d['dsc'];
		}
	});
	NS.Scope = Scope;

	var ScopeList = function(d){
		ScopeList.superclass.constructor.call(this, d, Scope);
	};
	YAHOO.extend(ScopeList, NS.ItemList, {});
	NS.ScopeList = ScopeList;

	var ScopeManager = function(){
		this.init();
	};
	ScopeManager.prototype = {
		init: function(callback){
			this._cache = {};
			this.scopeChangedEvent = new YAHOO.util.CustomEvent('scopeChangedEvent');
		},
		ajax: function(data, callback){
			NS.jobManager.ajax(data, callback);
		},
		listLoad: function(userid, callback, reload){
			var cache = this._cache;
			if (reload){
				delete cache[userid];
			}
			if (cache[userid]){
				NS.life(callback, cache[userid]);
			}
			this.ajax({
				'do': 'scopelist',
				'userid': userid
			}, function(d){
				var list = new NS.ScopeList();
				if (!L.isNull(d)){
					list.update(d);
				}
				cache[userid] = list;
				NS.life(callback, list);
			});
		},
		listSave: function(sd, callback){ // save my scope
			var __self = this, cache = this._cache, userid = Brick.env.user.id;
			sd['do'] = 'scopesave';
			
			this.ajax(sd, function(d){
				var list = cache[userid];
				if (!list){
					list = cache[userid] = new NS.ScopeList();
				}
				if (!L.isNull(d)){
					list.update(d, true);
				}
				NS.life(callback, list);
				__self.scopeChangedEvent.fire(userid);
			});
		}
	};
	NS.ScopeManager = ScopeManager;
	NS.scopeManager = null;
	
	NS.API.initScopeManager = function(callback){
		NS.API.initJobManager(function(){
			if (L.isNull(NS.scopeManager)){
				NS.scopeManager = new ScopeManager(callback);
			}
			NS.life(callback, NS.scopeManager);
		});
	};
};