/*
@version $Id: scopeview.js 1542 2012-05-03 05:39:49Z roosit $
@package Abricos
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	mod:[
		{name: '{C#MODNAME}', files: ['categorylist.js', 'scopedit.js']}
	]
};
Component.entryPoint = function(NS){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var UID = Brick.env.user.id*1;
	
	var buildTemplate = this.buildTemplate;

	var ScopeListWidget = function(container, userid){
		userid = userid || Brick.env.user.id;
		this.init(container, userid);
	};
	ScopeListWidget.prototype = {
		init: function(container, userid){
			this.userid = userid;
			
			var TM = buildTemplate(this, 'scope,scoperow');
			container.innerHTML = TM.replace('scope');
			
			if (UID != userid*1){
				Dom.setStyle(TM.getEl('scope.beditc'), 'display', 'none');
			}
			
			var __self = this;
			NS.API.initScopeManager(function(man){
				man.listLoad(userid, function(list){
					__self._initWidget(list);
				});
			});
			this.editorWidget = null;
		},
		destroy: function(){
			NS.scopeManager.unsubscribe(this.onScopeChanged);
		},
		_initWidget: function(list){
			this.list = list;
			
			if (list.count() == 0 && this.userid == Brick.env.user.id){
				Dom.removeClass(this._TM.getEl('scope.isempty'), 'hide');
			}else{
				this.renderList();
			}
			NS.scopeManager.scopeChangedEvent.subscribe(this.onScopeChanged, this, true);
		},
		onClick: function(el){
			var tp = this._TId['scope'];
			switch(el.id){
			case tp['bedit']:
			case tp['beditc']:
				this.showEditorWidget(); return true;
			}
			return false;
		},
		onScopeChanged: function(evt, prm){
			if (this.userid != prm[0]){ return; }
			this.renderList();
		},
		showEditorWidget: function(){
			if (!L.isNull(this.editorWidget)){ return; }

			var TM = this._TM;
			Dom.addClass(TM.getEl('scope.isempty'), 'hide');
			Dom.addClass(TM.getEl('scope.scopelist'), 'hide');
			
			var __self = this;
			this.editorWidget = new NS.ScopeEditorWidget(TM.getEl('scope.editor'), this.list, function(tp){
				__self.editorWidget = null;
			});
		},
		renderList: function(){
			var TM = this._TM,
				lst = "";
			
			Dom.removeClass(TM.getEl('scope.scopelist'), 'hide');
			
			this.list.foreach(function(sc){
				var cat = NS.jobManager.categoryFind(sc.catid),
					ptl = '!!!', tl = '!!!';
				
				if (!L.isNull(cat)){
					tl = cat.title;
					var pcat = NS.jobManager.categoryFind(cat.parentid);
					if (!L.isNull(pcat)){
						ptl = pcat.title;
					}					
				}
				
				
				lst += TM.replace('scoperow', {
					'id': sc.id,
					'ptl': ptl,
					'tl': tl,
					'dsc': sc.descript
				});
			});
			TM.getEl('scope.list').innerHTML = lst;
		}
	};
	NS.ScopeListWidget = ScopeListWidget;
	
	var ProfileScopeListWidget = function(container, user){
		this.init(container, user);
	};
	ProfileScopeListWidget.prototype = {
		init: function(container, user){
			
			var TM = buildTemplate(this, 'widget');
			container.innerHTML = TM.replace('widget');

			this.widget = new ScopeListWidget(TM.getEl('widget.widget'), user.id);
			var __self = this;
			E.on(container, 'click', function(e){
                var el = E.getTarget(e);
                if (__self.onClick(el)){ E.preventDefault(e); }
            });
		},
		destroy: function(){
			this.widget.destroy();
		},
		onClick: function(el){
			return this.widget.onClick(el);
		}
	};
	NS.ProfileScopeListWidget = ProfileScopeListWidget;
};