<?php 
/**
 * @version $Id: module.php 1542 2012-05-03 05:39:49Z roosit $
 * @package Abricos
 * @subpackage Job
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * @author Alexander Kuzmin <roosit@abricos.org>
 */


/**
 * Модуль интернет-приложения Работа Фрилансера
 */
class JobModule extends Ab_Module {
	
	/**
	 * Конструктор
	 */
	public function __construct(){
		$this->version = "0.1.0.2";
		$this->name = "job";
		$this->takelink = "job";
		$this->permission = new JobPermission($this);
	}
	
	/**
	 * @return JobManager
	 */
	public function GetManager(){
		if (is_null($this->_manager)){
			require_once 'includes/manager.php';
			$this->_manager = new JobManager($this);
		}
		return $this->_manager;
	}

	public function GetContentName(){
		return 'index';
	}
	
	public function GetAppSourceInfo(){
		$appInfo = new AppSourceInfo($this);
		
		$appInfo->resource->Add("/modules/job/images/logo-96x96.png");
		$appInfo->resource->Add("/modules/job/images/app_icon.png");
		
		return $appInfo;
	}
	
}

/**
 * Статус задачи
 */
class JobTaskStatus {
	
}

class JobAction {
	
	/**
	 * Просматривать
	 * @var integer
	 */
	const VIEW	= 10;
	
	/**
	 * Писать
	 * @var integer
	 */
	const WRITE	= 30;
	
	/**
	 * Проаккаунт
	 * @var integer
	 */
	const PROACCOUNT = 35;
	
	/**
	 * Админ
	 * @var integer
	 */
	const ADMIN	= 50;
}

class JobPermission extends Ab_UserPermission {

	public function JobPermission(JobModule $module){
		// объявление ролей по умолчанию
		// используется при инсталяции модуля в платформе
		$defRoles = array(
			new Ab_UserRole(JobAction::VIEW, Ab_UserGroup::GUEST),
			new Ab_UserRole(JobAction::VIEW, Ab_UserGroup::REGISTERED),
			new Ab_UserRole(JobAction::VIEW, Ab_UserGroup::ADMIN),
			
			new Ab_UserRole(JobAction::WRITE, Ab_UserGroup::REGISTERED),
			new Ab_UserRole(JobAction::WRITE, Ab_UserGroup::ADMIN),
			
			new Ab_UserRole(JobAction::ADMIN, Ab_UserGroup::ADMIN)
		);
		parent::__construct($module, $defRoles);
	}

	public function GetRoles(){
		return array(
			JobAction::VIEW => $this->CheckAction(JobAction::VIEW),
			JobAction::WRITE => $this->CheckAction(JobAction::WRITE),
			JobAction::ADMIN => $this->CheckAction(JobAction::ADMIN)
		);
	}
}

// создать экземляр класса модуля и зарегистрировать его в ядре 
Abricos::ModuleRegister(new JobModule())

?>